/***************************************************************************
 *  Copyright (C) 2011 by Resara LLC                                       *
 *  brendan@resara.com                                                     *
 *                                                                         *
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or (at  *
 *  your option) any later version.                                        *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful, but    *
 *  WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 *  General Public License for more details.                               *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program; if not, write to the                          *
 *  Free Software Foundation, Inc.,                                        *
 *  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 *                                                                         *
 ***************************************************************************/

#ifndef DHCPCONFIGUREWIDGET_H
#define DHCPCONFIGUREWIDGET_H

#include <RdsEntityWidget>
#include <RdsDhcpManager>
#include "ui_dhcpconfigurewidget.h"

class DhcpConfigureWidget : public RdsEntityWidget, private Ui::DhcpConfigureWidget
{
	Q_OBJECT

public:
	DhcpConfigureWidget(RdsDhcpManager *manager, QWidget* parent = 0);
	~DhcpConfigureWidget();

signals:
	void reload();

protected slots:
	void on_ConfigureButton_clicked();

protected:
	ReturnValue getData();
	bool setData(QString id, QVariantMap fields);

private:
	RdsDhcpManager *_manager;
};

#endif

