/***************************************************************************
 *  Copyright (C) 2011 by Resara LLC                                       *
 *  brendan@resara.com                                                     *
 *                                                                         *
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or (at  *
 *  your option) any later version.                                        *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful, but    *
 *  WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 *  General Public License for more details.                               *
 *                                                                         *
 *  You should have received a copy of the GNU General Public License      *
 *  along with this program; if not, write to the                          *
 *  Free Software Foundation, Inc.,                                        *
 *  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 *                                                                         *
 ***************************************************************************/

#ifndef DRIVEMAPWIDGET_H
#define DRIVEMAPWIDGET_H

#include <QWidget>
#include "ui_drivemapwidget.h"

class DriveMapWidget : public QWidget, private Ui::DriveMapWidget
{
	Q_OBJECT
public:
	Q_PROPERTY(QString mapstring READ mapString WRITE setMapString);
	
	enum Type
	{
		User,
 		Group, 
   		Computer
	};
	
	DriveMapWidget(QWidget* parent = 0, Qt::WFlags fl = 0);
	~DriveMapWidget();

	QString mapString() const;
	void setMapString(const QString &mapstring);
	
signals:
	void changed();
	
public slots:
	void mapChanged();
	void on_AddButton_clicked();
	void on_RemoveButton_clicked();
	
private:
	QString genList(QStringList list) const;
	QStringList parseList(QString str) const;
	void addItem(QString dn);
	QPixmap _usericon;
	QPixmap _groupicon;
	QPixmap _computericon;
	bool _nochange;
	QStringList _ids;
};

#endif

