/***************************************************************************
 *  Copyright (C) 2011 by Resara LLC                                       *
 *  brendan@resara.com                                                     *
 *                                                                         *
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU Lesser General Public License as         *
 *  published by the Free Software Foundation; either version 2 of the     *
 *  License, or (at your option) any later version.                        *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful, but    *
 *  WITHOUT ANY WARRANTY; without even the implied warranty of             *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 *  Lesser General Public License for more details.                        *
 *                                                                         *
 *  You should have received a copy of the GNU Lesser General Public       *
 *  License along with this program; if not, write to the                  *
 *  Free Software Foundation, Inc.,                                        *
 *  59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.              *
 *                                                                         *
 ***************************************************************************/
#ifndef RDSSHAREMANAGER_P_H
#define RDSSHAREMANAGER_P_H

#include <QxtPimpl>
#include "rdssharemanager.h"
#include "rdssambaconfigparser.h"
#include <RdsVolumeManager>
#include <QMutex>

/**
	@author Chris Vickery <chris@resara.com>
*/
class RdsShareManagerPrivate : public QxtPrivate<RdsShareManager>
{
public:
	RdsShareManagerPrivate()
	{
	}
	RdsSambaConfigParser parser;
	
	static void writeLogonScript(RdsShareManager *mgr);
	static QStringList parseList(QString str);
	static QString getMapCommand(QString mapstring, QString sharename);
	static void updateIniFile(QString path);
	static void connectVolumeEvents(RdsShareManager *mgr);
	static void updateVolumePaths();
	static QMutex volmutex;
	static RdsVolumeManager *volmgr;
	static QHash<QString, QString> volumepaths;
};

#endif
